## Copyright/Non-Copyright Statements

**bulk_extractor** was originally developed by Simson Garfinkel while at
the Naval Postgraduate School. As a work of the US Government that
work is not subject to copyright law.

Simson Garfinkel left the Naval Postgraduate School in January 2015
and continued to work on **bulk_extractor** in his personal
capacity. Those modifications are covered under the MIT license (below). Other
components are licensed as noted.

## MIT License

Copyright (C) 2020, Simson L. Garfinkel

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
OR OTHER DEALINGS IN THE SOFTWARE.

## CC0 Original Summary

Except as otherwise noted, bulk_extractor source code files are public domain
software.

That software provided here is released by the Naval Postgraduate
School, an agency of the U.S. Department of Navy.  The software bears
no warranty, either expressed or implied. NPS does not assume legal
liability nor responsibility for a User's use of the software or the
results of such use.

Please note that within the United States, copyright protection, under
Section 105 of the United States Code, Title 17, is not available for
any work of the United States Government and/or for any works created
by United States Government employees.

However, because some bulk_extractor source modules (e.g. pyxpress.c)
are covered under the GNU Public License, the compiled bulk_extractor
executable is covered under the GPL copyright. This means that binary
distributions of bulk_extractor must include the full source code (or
have the source code be made easily available.)

## Other materials

bulk_extractor provides other materials with different licenses than the
ones mentioned previously. Copies of the licenses mentioned below can be
found under the licenses/ directory.

Licensed under the Common Public License 1.0

* src/tsk3 includes SleuthKit 3 include files that are party of
SleuthKit 3. These files are  Copyright (C) 2010 Brian Carrier


Licensed under the MIT License

* src/base64_forensic.cpp is Copyright (C) 1996-1999 by Internet Software Consortium, with
 portions Copyright (C) 1995 by International Business Machines, Inc.

* src/be13_api/utf8.h is Copyright 2006 Nemanja Trifunovic

* src/old_scanners/scan_ascii85.cpp is Copyright (C) 2011 Remy Oukaour

* src/scan_json.cpp is Copyright (C) 2021 Simson L. Garfinkel and Jan Gruber


Licensed under General Public License version 3 and later

* src/pyxpress.c is Copyright 2008 (C) Matthieu Suiche. <msuiche[at]gmail.com>


Licensed under Lesser General Public License version 2.1

* src/scan_elf.cpp


Licensed under Lesser General Public License version 3 and later

* src/dfxml is Copyright 2012 (C) Simson L. Garfinkel

* src/scan_outlook.h is Copyright (C) 2008-2014, Joachim Metz <joachim.metz@gmail.com>


Licensed under General Public License version 3 with the Autoconf exception:

* m4/ac_prog_java.m4 is Copyright (C) 2000 Stephane Bortzmeyer <bortzmeyer@pasteur.fr>

* m4/ac_prog_java_works.m4 is Copyright (C) 2000 Stephane Bortzmeyer <bortzmeyer@pasteur.fr>

* m4/ac_check_rqrd_class.m4 is Copyright (C) 2000 Stephane Bortzmeyer <bortzmeyer@pasteur.fr>

* m4/ax_pthread.m4 is Copyright (C) 2008 Steven G. Johnson <stevenj@alum.mit.edu>,
 2011 Daniel Richard G. <skunk@iSKUNK.ORG>

* m4/ac_prog_java_cc.m4 is Copyright (C) 2002 Nic Ferrier <nferrier@tapsellferrier.co.uk>

* m4/ac_prog_javac.m4 is Copyright (C) 2000 Stephane Bortzmeyer <bortzmeyer@pasteur.fr>

* m4/ac_prog_javac_works.m4 is Copyright (C) 2000 Stephane Bortzmeyer <bortzmeyer@pasteur.fr>

* m4/ac_check_classpath.m4 is Copyright (C) 2000 Stephane Bortzmeyer <bortzmeyer@pasteur.fr>

Because parts the GPL (including version 3) is incompatible with some terms of the OpenSSL license, the author hereby explicitly states a license exception, which permits the linking of bulk_extractor with OpenSSL.
